## mingw-w64-adios2-2.10.2-1.src.tar.zst

=== plugins/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

add_subdirectory(operators)
add_subdirectory(engines)
