=== thirdparty/EVPath/EVPath/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

# The directory label is used for CDash to treat EVPath as a subproject of
# GTKorvo
set(CMAKE_DIRECTORY_LABELS EVPath)

project(EVPath VERSION 4.5.0 LANGUAGES C CXX)

# Enable <PackageName>_ROOT variables for dependency searching
# CMake v3.12
if(POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()

# Enable imported targets as library dependencies for CHECK_INCLUDE_FILE
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

# Let option(...) setings work with non-cache variables.  Useful for including
# EVPath as a third party dependency in another project.
# CMake v3.13
if(POLICY CMP0077)
  cmake_policy(SET CMP0077 NEW)
endif()

# Some boilerplate to setup nice output directories
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKEDIR ${CMAKE_INSTALL_LIBDIR}/cmake/EVPath
  CACHE STRING "Installation CMake subdirectory")
mark_as_advanced(CMAKE_INSTALL_CMAKEDIR)

set(EVPATH_INSTALL_MODULE_DIR "${CMAKE_INSTALL_LIBDIR}"
  CACHE STRING "Directory in which to install EVPath transport modules")
mark_as_advanced(EVPATH_INSTALL_MODULE_DIR)

if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
endif()
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY
    ${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
endif()
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

if(NOT DEFINED EVPATH_RUNTIME_COMPONENT)
  set(EVPATH_RUNTIME_COMPONENT bin)
endif()
if(NOT DEFINED EVPATH_LIBRARY_COMPONENT)
  set(EVPATH_LIBRARY_COMPONENT shlib)
endif()
if(NOT DEFINED EVPATH_ARCHIVE_COMPONENT)
  set(EVPATH_ARCHIVE_COMPONENT lib)
endif()
if(NOT DEFINED EVPATH_HEADER_COMPONENT)
  set(EVPATH_HEADER_COMPONENT dev)
endif()
if(NOT DEFINED EVPATH_MODULE_COMPONENT_PREFIX)
  set(EVPATH_MODULE_COMPONENT_PREFIX "")
endif()

# Default to a RelWithDebInfo build if not specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE RelWithDebInfo)
endif()

if(NOT MSVC)
  set(CMAKE_C_STANDARD 99)
  set(CMAKE_C_STANDARD_REQUIRED True)
endif()

if(WIN32)
  # Automagic to do the DLL / LIB song and dance
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

  # Silence MSVC warnings
  if(CMAKE_C_COMPILER_ID MATCHES "MSVC" OR
     CMAKE_C_SIMULATE_ID MATCHES "MSVC")
    add_definitions(
      -D_CRT_SECURE_NO_DEPRECATE
      -D_CRT_SECURE_NO_WARNINGS
      -D_SCL_SECURE_NO_DEPRECATE
      -D_WINSOCK_DEPRECATED_NO_WARNINGS
      -D_CRT_NONSTDC_NO_DEPRECATE)
    set (MSVC_PERL_FLAGS "-msvc-long")
  endif()
endif()

set(CPACK_DEBIAN_PACKAGE_DEPENDS "dill, atl, ffs")
set(CPACK_RPM_PACKAGE_REQUIRES "dill, atl, ffs")
set(ENABLE_SOMETHING AUTO CACHE STRING "Enable SOMETHING support")  #
set(EVPATH_DEFAULT_PORT_RANGE  "26000:26100" CACHE STRING "Default port range for IP communication")
mark_as_advanced(EVPATH_DEFAULT_PORT_RANGE)

include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckTypeSize)
include(CheckStructHasMember)
include(CheckCSourceRuns)
include(TestBigEndian)
include(CheckBrokenTitanCompiler)

include(CTest)
configure_file(CTestCustom.ctest.in CTestCustom.ctest @ONLY)

include(CMakeDependentOption)

# Setup shared library defaults.  If explicitly specified somehow, then default 
# to that.  Otherwise base the default on whether or not shared libs are even
# supported.
get_property(SHARED_LIBS_SUPPORTED GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS)
cmake_dependent_option(BUILD_SHARED_LIBS
  "Build shared libraries (so/dylib/dll)." ${SHARED_LIBS_SUPPORTED}
  "SHARED_LIBS_SUPPORTED" OFF
)
mark_as_advanced(BUILD_SHARED_LIBS)

if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  endif()
elseif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  # Update if necessary
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall ")
endif()

add_library(EVPath
  cm.c cm_control.c cm_formats.c cm_util.c cm_transport.c 
  cm_lock.c cm_perf.c cm_pbio.c cm_interface.c version.c
  cm_threadio.c cm_evol.c evp.c response.c metrics.c 
  dlloader.c ip_config.c chr_time.c
  revp.c evp_compat.c thin_server.c evp_threads.c ev_dfg.c)
add_library(EVPath::EVPath ALIAS EVPath)
add_library(evpath ALIAS EVPath)
target_include_directories(EVPath PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

function(_pkg_get_target_prefix tgt out_prefix)
  set(prefix)
  get_property(inc TARGET ${tgt} PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
  get_filename_component(prefix "${inc}" PATH)
  set(${out_prefix} "${prefix}" PARENT_SCOPE)
endfunction()

set(_pkg_config_pfxs
  "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig")
set(_pkg_config_reqs)
set(_pkg_config_private_reqs)
set(_pkg_config_libs)
set(_pkg_config_private_libs)

include(CheckCSourceCompiles)

# Avoid recent compilers to optimizing out libm function calls
set(CMAKE_REQUIRED_FLAGS "-O0")
set(LIBM_TEST_SOURCE "#include<math.h>\nfloat f; int main(){sqrt(f);return 0;}")
check_c_source_compiles("${LIBM_TEST_SOURCE}" HAVE_MATH)
if(NOT HAVE_MATH)
  set(CMAKE_REQUIRED_LIBRARIES m)
  check_c_source_compiles("${LIBM_TEST_SOURCE}" HAVE_LIBM_MATH)
  unset(CMAKE_REQUIRED_LIBRARIES)
  if(NOT HAVE_LIBM_MATH)
    message(FATAL_ERROR "Unable to use C math library functions")
  endif()
    
  target_link_libraries(EVPath PRIVATE m)
  list(APPEND _pkg_config_private_libs m)
endif()

set(EVPATH_LIBRARY_PREFIX "" CACHE STRING
  "Prefix to prepend to the output library name")
mark_as_advanced(EVPATH_LIBRARY_PREFIX)
set_target_properties(EVPath PROPERTIES
  OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}evpath)

set(IPCONFIG_ENVVAR_PREFIX "CM_" CACHE STRING
  "Prefix to prepend to the networking environment variable names")
mark_as_advanced(IPCONFIG_ENVVAR_PREFIX)
if (NOT EVPATH_LIBRARY_PREFIX STREQUAL "")
   STRING (TOUPPER ${EVPATH_LIBRARY_PREFIX} IPCONFIG_ENVVAR_PREFIX)
endif()
   
mark_as_advanced(EVPATH_LIBRARY_PREFIX)

set(EVPATH_TRANSPORT_DEP_LIBS)

if(NOT DEFINED CM_SELF_FORMATS)
  set(CM_SELF_FORMATS 1)
endif()

if (DEFINED EVPATH_NO_RDMA) 
  option(EVPATH_NO_RDMA "Don't use any RDMA library"
    "${EVPATH_NO_RDMA}")
  if (EVPATH_NO_RDMA)
    SET (EVPATH_USE_LIBFABRIC OFF)
    SET (EVPATH_USE_NNTI OFF)
    SET (EVPATH_USE_IBVERBS OFF)
  endif()
endif()

cmake_dependent_option(EVPATH_TRANSPORT_MODULES
  "Enable stand-alone transport modules" ${BUILD_SHARED_LIBS}
  "SHARED_LIBS_SUPPORTED" OFF
)

list(INSERT CMAKE_PREFIX_PATH 0 ${CMAKE_INSTALL_PREFIX})
find_package(atl 2.2.1 REQUIRED)
find_package(ffs 3.0.0 REQUIRED)
_pkg_get_target_prefix(atl::atl atl_PREFIX)
_pkg_get_target_prefix(ffs::ffs ffs_PREFIX)
list(APPEND _pkg_config_pfxs "${atl_PREFIX}" "${ffs_PREFIX}")

if(TARGET ffs) # The unaliased target exists so it's built by us
  set(HAVE_COD_H TRUE CACHE INTERNAL "" FORCE)
else()
  set(CMAKE_REQUIRED_LIBRARIES ffs::ffs)
  CHECK_INCLUDE_FILE(cod.h HAVE_COD_H)
  unset(CMAKE_REQUIRED_LIBRARIES)
endif()
if (HAVE_COD_H)
   find_package(dill 3.0.0 REQUIRED)
   target_link_libraries(EVPath PUBLIC atl::atl ffs::ffs PRIVATE dill::dill)
   _pkg_get_target_prefix(dill::dill dill_PREFIX)
   list(APPEND _pkg_config_private_reqs "dill >= ${dill_VERSION}")
   list(APPEND _pkg_config_pfxs "${dill_PREFIX}")
else()
   target_link_libraries(EVPath PUBLIC atl::atl ffs::ffs)
endif()

find_package(Threads)
if(Threads_FOUND)
  target_link_libraries(EVPath PRIVATE ${CMAKE_THREAD_LIBS_INIT})
  list(APPEND _pkg_config_private_libs ${CMAKE_THREAD_LIBS_INIT})
endif()

if(DEFINED EVPATH_USE_NVML)
  option(EVPATH_USE_NVML "Use the NVidia management library"
    "${EVPATH_USE_NVML}")
  if(EVPATH_USE_NVML)
    find_package(NVML REQUIRED)
  endif()
else()
  find_package(NVML)
  option(EVPATH_USE_NVML "Use the NVidia management library" ${NVML_FOUND})
endif()
if(NVML_FOUND)
  if(NOT BUILD_SHARED_LIBS)
    list(APPEND EXTRA_INSTALL_PACKAGES NVML)
  endif()
  target_link_libraries(EVPath PRIVATE nvml::nvml)
  list(APPEND _pkg_config_private_libs ${NVML_LIBRARIES})
endif()

include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(clock_gettime time.h HAVE_CLOCK_GETTIME)

if(NOT HAVE_CLOCK_GETTIME)
  include(CheckLibraryExists)
  CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
  if(HAVE_CLOCK_GETTIME)
    target_link_libraries(EVPath PRIVATE rt)
    list(APPEND _pkg_config_private_libs rt)
  endif()
endif()

CHECK_INCLUDE_FILE(sys/epoll.h HAVE_SYS_EPOLL_H)
set(CM_DEFAULT_SELECT "select")
if (HAVE_SYS_EPOLL_H)
   set(CM_DEFAULT_SELECT "epoll")
endif()
set(CM_DEFAULT_TRANSPORT "sockets")

# This is a dummy interace library to allow the transport modules to depend on
# the EVPath headers without causing an unnecessary link dependency
add_library(evpath_headers INTERFACE)
set_target_properties(evpath_headers PROPERTIES
  INTERFACE_INCLUDE_DIRECTORIES
    "${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR};$<TARGET_PROPERTY:ffs::ffs,INTERFACE_INCLUDE_DIRECTORIES>;$<TARGET_PROPERTY:atl::atl,INTERACE_INCLUDE_DIRECTORIES>"
)

set(EVPATH_TRANSPORT_TARGETS)
if(EVPATH_TRANSPORT_MODULES)
  target_link_libraries(EVPath PRIVATE ${CMAKE_DL_LIBS})

  add_library(cmselect MODULE cmselect.c)
  add_library(cmsockets MODULE cmsockets.c ip_config.c)
  add_library(cmudp MODULE cmudp.c)
  add_library(cmmulticast MODULE cmmulticast.c)

  foreach(M cmselect cmsockets cmudp cmmulticast)
    set_target_properties(${M} PROPERTIES
      OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}${M}
      LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR}
      WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    install(TARGETS ${M} DESTINATION ${EVPATH_INSTALL_MODULE_DIR} COMPONENT ${EVPATH_MODULE_COMPONENT_PREFIX}${M})
  endforeach()

  target_link_libraries(cmselect PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmsockets PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmudp PRIVATE evpath_headers atl::atl)
  target_link_libraries(cmmulticast PRIVATE evpath_headers atl::atl)

  list(APPEND EVPATH_TRANSPORT_TARGETS cmselect cmsockets cmudp cmmulticast)

  if (HAVE_SYS_EPOLL_H)
     add_library(cmepoll MODULE cmepoll.c)
     set_target_properties(cmepoll PROPERTIES
          OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}cmepoll
          LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR})
     target_link_libraries(cmepoll PRIVATE evpath_headers atl::atl)
     list(APPEND EVPATH_TRANSPORT_TARGETS cmepoll)
     install(TARGETS cmepoll DESTINATION ${EVPATH_INSTALL_MODULE_DIR} COMPONENT ${EVPATH_MODULE_COMPONENT_PREFIX}cmepoll)
  endif()
else()
  # dummy dyn linking in cm.c and cm_transport.c
  set(NO_DYNAMIC_LINKING 1)

  target_sources(EVPath PRIVATE cmsockets.c)
  target_sources(EVPath PRIVATE cmselect.c)
  if (HAVE_SYS_EPOLL_H)
    target_sources(EVPath PRIVATE cmepoll.c)
  endif()
  target_sources(EVPath PRIVATE cmudp.c)
  target_sources(EVPath PRIVATE cmmulticast.c)
endif()

set(RUN_NNTI_TESTS FALSE)

# enet transport
set(RUN_ENET_TESTS FALSE)
if(DEFINED EVPATH_USE_ENET)
  option(EVPATH_USE_ENET "Build the enet transport" "${EVPATH_USE_ENET}")
  if(EVPATH_USE_ENET)
    find_package(enet 1.3.13 REQUIRED)
  endif()
else()
  find_package(enet 1.3.13 QUIET)
  option(EVPATH_USE_ENET "Build the enet transport" ${ENET_FOUND})
endif()
if(ENET_FOUND)
  set(RUN_ENET_TESTS TRUE)
  if(EVPATH_TRANSPORT_MODULES)
    add_library(cmenet MODULE cmenet.c ip_config.c)
    set_target_properties(cmenet PROPERTIES
      OUTPUT_NAME ${EVPATH_LIBRARY_PREFIX}cmenet
      LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${EVPATH_INSTALL_MODULE_DIR})
